/* -*- Mode: java; tab-width: 8; c-basic-offset: 4 -*-
 * Copyright  1997, 1998 Netscape Communications Corporation, All Rights Reserved.
 */

package com.netscape.javascript.CORBA;

import com.netscape.javascript.*;
import org.omg.CORBA.TCKind;
import org.omg.CORBA.TypeCode;
import org.omg.CORBA.Any;
import org.omg.CORBA.portable.*;
import java.util.Hashtable;
import java.util.Enumeration;


/**
 * This class reflects a IDL enums into the JS
 * environment.
 *
 * @author Ruslan Belkin
 */

public class   Enum extends Simple  {

    public Enum (Any value)
    {
        super (value);
    }

    public Enum (TypeCode tc)
    {
        super (tc);
    }
    
    public String getClassName ()   
    {
        return "Enum";
    }
   
    public String toString ()
    {
        String s = getClassName () + ":";

        try {
            s += any.type ().id ();
        }
        catch (Exception e) {   s+= "unknown";  };

        s += "={";       
        for (Enumeration e = hashtbl.keys () ; ; )
        {
            Object o = e.nextElement ();
            s += o + "=" + hashtbl.get (o);
            if (!e.hasMoreElements ())
                break;
            s += ";";
        }

        s += "}";
        return s;
    }

    public Object valueOf ()
    {
        return this;
    }

    public boolean has (String id, Scriptable start)
    { 
        return id != null && hashtbl.containsKey (id);
    }

    public Object  get (String id, Scriptable start)
    {
        return has (id, start) ? hashtbl.get (id) : Scriptable.NOT_FOUND;
    }    
   
    public void decode ()
    {
        TypeCode tc = any.type ();            
        
        hashtbl = new Hashtable ();

        try {
            int mcount = tc.member_count ();
            
            for (int i = 0; i < mcount; i++)
                hashtbl.put (tc.member_name (i), new Integer (i));
        }
        catch (org.omg.CORBA.UserException e) {   }
    }

    Hashtable hashtbl;
}
