// StockMarketServer.java

import DreamStocks.*;
import org.omg.CORBA.*;
import java.io.* ;
import java.net.*;
import java.lang.*;
import com.visigenic.vbroker.URLNaming.*;

class StockMarketImpl	extends _StockMarketImplBase
{
	DreamStocks.StockAlert alert_obj;

	public StockMarketImpl (String name) 
	{
		super (name);
		alert_obj = null;
	}

	public float get_quote (String symbol)
	{
		if (alert_obj != null)
		{
			IntHolder p = new IntHolder (10);
			System.out.println ("Invoking alert_obj.price_change");
			try {
			    System.out.println ("Result: " + alert_obj.price_change (symbol, 26, p));
			}
			catch (org.omg.CORBA.UserException ue)
			{
			    System.out.println ("price_change: exception caught: " + ue);
			}
			System.out.println ("Test cookie: " + p.value);
		};

		try {
		    Float v = Float.valueOf (symbol);
		    return v.floatValue ();
		}
		catch (NumberFormatException fe)
		{
		    return (float)Math.random () * 100;
		}
	}

	public Raitings get_raiting (String symbol)
	{
		System.out.println ("get_raiting (" + symbol + ")");
		if (symbol.equals ("NSCP"))	return Raitings.MODERATEBUY;
		return Raitings.HOLD;
	}

	public ExtendedQuote get_extended_quote (String symbol)
	{
		ExtendedQuote d = new ExtendedQuote ();
		Fundamentals  f = new Fundamentals  ();

		d.quote  = (float)Math.random () * 100;
		d.volume = 4000;
		f.pe = 20;
		d.fundamentals = f;
		return d;
	}

	public float [] get_weekly_quote (String symbol)
	{
		float [] p = new float[7];

		for (int i = 0; i < 7; i++)
			p[i] = (float)Math.random () * 100;
		return p;
	}
	public void setupStockAlert (DreamStocks.StockAlert alert)
	{
		alert_obj = alert;
		System.out.println ("setupStockAlert");
	}

	public void removeStockAlert ()
	{
		alert_obj = null;
		System.out.println ("removeStockAlert");
	}


	public static void main (String[] args)
	{
	    try {

		if (args.length > 1)
		{
		    System.out.println ("Usage: StockMarketImpl [file|url]");
		    return;
		}

		ORB orb = ORB.init ();
		BOA boa = orb.BOA_init ();

		System.out.println ("Initializing StockMarket object ...");
		StockMarketImpl impl = new StockMarketImpl ("NASDAQ");

		boa.obj_is_ready (impl);

		String filename = "/tmp/ior.dat";

		if (args.length == 1)
		{
		    try {
		        URL x = new URL (args[0]);

			try {
			    ResolverImpl resolver = new ResolverImpl ();
			    resolver.init ((com.visigenic.vbroker.orb.ORB)orb, null);
			    resolver.force_register_url (args[0], impl);

			    filename = null;
			}
			catch (Exception e) 
			{
		            System.out.println ("Failure to register URL name: " + e);
			}	

		    }
		    catch (MalformedURLException urle)
		    {
			filename = args[0];
	     	    }
		}

		// Save IOR into file to test str2obj functionality
		if (filename != null)
		{
		    try {
			PrintWriter out = new PrintWriter (
						new BufferedWriter (
							new FileWriter (filename)
						)
					  );

			String ior = orb.object_to_string (impl);

			System.out.println ("Saving IOR into " + filename);	
			out.println (ior);
			out.close ();
		    }
		    catch (IOException ioe)
		    {
			System.out.println ("Failure to save IOR to " + filename + " " + ioe);
		    }
		}


		System.out.println ("Listening ...");
		boa.impl_is_ready ();
	    }
	    catch (SystemException e) 
	    {
		System.err.println (e);
	    }
	}
}
